﻿using Excavator.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace Excavator.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningTrackedVehicleEqutables : IEqualityComparer<DrawningTrackedVehicle?>
{
    public bool Equals(DrawningTrackedVehicle? x, DrawningTrackedVehicle? y)
    {
        if (x == null || x.EntityTrackedVehicle == null)
        {
            return false;
        }
        if (y == null || y.EntityTrackedVehicle == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityTrackedVehicle.Speed != y.EntityTrackedVehicle.Speed)
        {
            return false;
        }
        if (x.EntityTrackedVehicle.Weight != y.EntityTrackedVehicle.Weight)
        {
            return false;
        }
        if (x.EntityTrackedVehicle.BodyColor != y.EntityTrackedVehicle.BodyColor)
        {
            return false;
        }
        if (x is DrawningExcavator && y is DrawningExcavator)
        {
            if ((x.EntityTrackedVehicle as EntityExcavator)?.AdditionalColor !=
                (y.EntityTrackedVehicle as EntityExcavator)?.AdditionalColor)
            {
                return false;
            }
            if ((x.EntityTrackedVehicle as EntityExcavator)?.Supports !=
                (y.EntityTrackedVehicle as EntityExcavator)?.Supports)
            {
                return false;
            }
            if ((x.EntityTrackedVehicle as EntityExcavator)?.Bucket !=
                (y.EntityTrackedVehicle as EntityExcavator)?.Bucket)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningTrackedVehicle? obj)
    {
        return obj.GetHashCode();
    }
}


