﻿using Excavator.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Excavator.Drawnings;
/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawningTrackedVehicleCompareByColor : IComparer<DrawningTrackedVehicle?>
{
    public int Compare(DrawningTrackedVehicle? x, DrawningTrackedVehicle? y)
    {
        if (x == null || x.EntityTrackedVehicle == null)
        {
            return 1;
        }
        if (y == null || y.EntityTrackedVehicle == null)
        {
            return -1;
        }
        var bodyColorCompare = y.EntityTrackedVehicle.BodyColor.Name.CompareTo(x.EntityTrackedVehicle.BodyColor.Name);
        if (bodyColorCompare != 0)
        {
            return bodyColorCompare;
        }
        if (x is DrawningExcavator && y is DrawningExcavator)
        {
            var additionalColorCompare = (y.EntityTrackedVehicle as EntityExcavator).AdditionalColor.Name.CompareTo(
                (x.EntityTrackedVehicle as EntityExcavator).AdditionalColor.Name);
            if (additionalColorCompare != 0)
            {
                return additionalColorCompare;
            }
        }
        var speedCompare = y.EntityTrackedVehicle.Speed.CompareTo(x.EntityTrackedVehicle.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityTrackedVehicle.Weight.CompareTo(x.EntityTrackedVehicle.Weight);

    }
}
