﻿using Excavator.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Excavator.CollectionGenericObjects;
/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawningTrackedVehicleCompareByType : IComparer<DrawningTrackedVehicle?>
{
    public int Compare(DrawningTrackedVehicle? x, DrawningTrackedVehicle? y)
    {
        if (x == null || x.EntityTrackedVehicle == null)
        {
            return 1;
        }
        if (y == null || y.EntityTrackedVehicle == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return y.GetType().Name.CompareTo(x.GetType().Name);
        }
        var speedCompare = y.EntityTrackedVehicle.Speed.CompareTo(x.EntityTrackedVehicle.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityTrackedVehicle.Weight.CompareTo(x.EntityTrackedVehicle.Weight);
    }
}