﻿using System.Runtime.Serialization;

namespace Excavator.Exceptions;

/// <summary>
/// Класс, описывающий ошибку переполнения коллекции
/// </summary>
[Serializable]
internal class ObjectAlreadyInCollectionException : ApplicationException
{
    public ObjectAlreadyInCollectionException(int index) : base("Такой объект уже присутствует в коллекции. Позиция " + index) { }

    public ObjectAlreadyInCollectionException() : base() { }

    public ObjectAlreadyInCollectionException(string message) : base(message) { }

    public ObjectAlreadyInCollectionException(string message, Exception exception) : base(message, exception) { }

    protected ObjectAlreadyInCollectionException(SerializationInfo info, StreamingContext contex) : base(info, contex) { }
}

